import os, operator
import psycopg2
import time
import sys
import zipfile
import Daemon
import logging
from stat import *
import grp
import shutil
import re

class goosProcDaemon(Daemon.Daemon):
    def run(self):
    
        global AMVERWorkDir, NOSFileDir, ARCHLog, Messages, BAD, WMO_Header

#        print  "goosProcDaemon"
        NOSFileDir = AMVERWorkDir+"NOSSRVR_lftp"
        if not os.path.exists(NOSFileDir+'/binfiles'):
            os.makedirs(NOSFileDir+'/binfiles')
            
          
            
        if not os.path.exists(NOSFileDir+'/goos'):
            os.makedirs(NOSFileDir+'/goos')
            
        if not os.path.exists(NOSFileDir+'/goos/logfiles'):
            os.makedirs(NOSFileDir+'/goos/logfiles')
         
        if not os.path.exists(NOSFileDir+'/goos/archive'):
            os.makedirs(NOSFileDir+'/goos/archive')
           
            
            
        ARCHFile = NOSFileDir+"/goos/logfiles/Logfile.log" 
        ARCHLog=logging.getLogger("ArchLog")
        ARCHLog.setLevel(logging.DEBUG)
        handler = logging.FileHandler(ARCHFile)
        Form = logging.Formatter('%(asctime)s %(levelname)-8s %(module)s %(lineno)d %(message)s','%a, %d %b %Y %H:%M:%S')
        handler.setFormatter(Form)
        ARCHLog.addHandler(handler)

        ARCHLog.debug('AMVERWorkDir = %s' %AMVERWorkDir)
        ARCHLog.debug('NOSFileDir = %s' %NOSFileDir)
        
#        goosMainProc()
#        sys.exit(0)

        TimeTrig=False
        OneMinute = 0
        while True:
##        
            while True:
                TM = time.gmtime(time.time())
                if TM.tm_hour == 6  and TM.tm_min==15 and TimeTrig == False:
#       	        if TM.tm_min%5==0 and TimeTrig == False:
                    TimeTrig = True
#                    print "min = twelve"
                    break
                else:
                    if TM.tm_hour == 6  and TM.tm_min==15 and TimeTrig == True:
          #           if TM.tm_min%5==0 and TimeTrig==True:
                        time.sleep(60)
                        
                    else:
                        time.sleep(5)
                        TimeTrig=False
                        OneMinute+=1
                        if OneMinute == 12:
                            OneMinute=0
                            st = os.stat(pidfile) # Touch the pid file so we know we are still running
                            atime = st[ST_ATIME]
                            FT = time.time()
                            os.utime(pidfile,(atime,FT))
                        
#                    print TM
                    continue
            goosMainProc()
#            sys.exit(0)


def ProcNNXX():
    RetRecords = []
    for rec in Messages:
        try:
	        tokens = rec.split()
	#        print tokens
	#        print
	        offset =0
	        if len(tokens)<=3:
	            continue
	        if tokens[0].upper()=='NNXX':
	            del tokens[0]
	            
	        OD = tokens[0][0:2] # Ob Day
	        OM = tokens[0][2:4] # ob Month
	        OY1 = tokens[0][4:5] # ob Year digit
	        OT = '9999'
	        Quad = ''
	        lat_deg = 99
	        lat_min = 99
	        lon_deg = 999
	        lon_min = 99

	        WMO_ID = tokens[len(tokens)-1]
	        
	        if OD.isdigit() and OM.isdigit() and OY1.isdigit() and OT.isdigit():
	            if int(OY1) > now.tm_year%10:  ## year in observation greater than last digit in current year
	                if int(OY1) - now.tm_year%10 == 1:
	                    OY = now.tm_year-1
	                elif int(OY1) - now.tm_year%10 > 1:  ## more than one year must be from previous decade
	                    OY = now.tm_year/10*10 + int(OY1)-10
	            else:
	                OY = now.tm_year/10*10 +int(OY1)
	                
	            OD = int(OD)
	        else:
	            OD=now.tm_mday
	            OM=now.tm_mon
	            OY = now.tm_year
	            OT = str(now.tm_hour*100+now.tm_min)
	        flags = []
	        for i in range(0,7):
	            flags.append(0)

	        for I in range(1,len(tokens)-1):
	            if tokens[I][len(tokens[I])-1]==('/') and tokens[I][0:len(tokens[I])-1].isdigit():
	                OT = OT = tokens[I][0:len(tokens[I])-1]
	                if tokens[I+1].isdigit():
	                    LAT = tokens[I+1][1:]
	                    Quad = int(tokens[I+1][0:1])
	                    lat_deg = int(LAT)/100
	                    lat_min = int(int(LAT)%100.0*0.6)
	                if tokens[I+2].isdigit():
	                    LON = tokens[I+2][1:]
	                    lon_deg = int(LON)/100
	                    lon_min = int(int(LON)%100.0*0.6)
	                if tokens[I+3].isdigit() and tokens[I+3][0:1] == '4':
	                    if tokens[I+4].isdigit() and tokens[I+4][0:1] == '6':
	                        flags[5]=1
	                elif tokens[I+3].isdigit() and tokens[I+3][0:1] == '6':
	                        flags[5]=1
	                        
	                Lat_Quad=''
	                Lon_Quad=''
	                if Quad == 7:
	                    Lat_Quad= 'N'
	                    Lon_Quad= 'W'
	                elif Quad == 5:
	                    Lat_Quad= 'S'
	                    Lon_Quad= 'W'
	                elif Quad == 3:
	                    Lat_Quad= 'S'
	                    Lon_Quad= 'E'
	                elif Quad == 1:
	                    Lat_Quad= 'N'
	                    Lon_Quad= 'E'

	                OutRec = []
	                OutRec.append(WMO_ID)
	                OutRec.append('%02d/%02d/%04d' %(int(OM),int(OD),int(OY)))
	                OutRec.append('%04d' %(int(OT)))
	                OutRec.append(WMO_Header)
	        #        print "ProcBathy ", WMO_Header
	                OutRec.append('%02d/%02d/%04d' %(HM,HD,HY))
	                OutRec.append('%04d' %(int(HT)))
	                OutRec.append('%02d/%02d%s' %(lat_deg,lat_min,Lat_Quad))
	                OutRec.append('%03d/%02d%s' %(lon_deg,lon_min,Lon_Quad))
	                
	                for i in range(0, len(flags)):
	                    OutRec.append('%d' %flags[i])

	                type='N'
	                OutRec.insert(0,type)
	        #        print OutRec
	                RetRecords.append(OutRec)
        except Exception, e:
            ARCHLog.exception(str(e))
            BAD.write('%s\r\n\n' %rec)
            continue

    return RetRecords



def ProcZZYY():
    RetRecords = []
    for rec in Messages:
        try:
	        tokens = rec.split()
	#        print tokens
	#        print
	        offset =0
	        if len(tokens)<=3:
	            continue
	#        print "Length of tokens is ", len(tokens)
	            
	        WMO_ID=tokens[1]
	        now = time.gmtime()   
	#        print tokens
	        OD = tokens[2][0:2] # Ob Day
	        OM = tokens[2][2:4] # ob Month
	        OY1 = tokens[2][4:5] # ob Year digit
	        OT = tokens[3][0:4]
	        
	        
	        if OD.isdigit() and OM.isdigit() and OY1.isdigit() and OT.isdigit():
	            if int(OY1) > now.tm_year%10:  ## year in observation greater than last digit in current year
	                if int(OY1) - now.tm_year%10 == 1:
	                    OY = now.tm_year-1
	                elif int(OY1) - now.tm_year%10 > 1:  ## more than one year must be from previous decade
	                    OY = now.tm_year/10*10 + int(OY1)-10
	            else:
	                OY = now.tm_year/10*10 +int(OY1)
	                
	            OD = int(OD)
	##            OY = now.tm_year/10*10 + (now.tm_year%10 -int(OY1)+1) ## Adjust year if necessary
	        else:
	            OD=now.tm_mday
	            OM=now.tm_mon
	            OY = now.tm_year
	            OT = str(now.tm_hour*100+now.tm_min)
	            
	        if tokens[4].isdigit():
	            LAT = tokens[4][1:]
	            Quad = int(tokens[4][0:1])
	            lat_deg = int(LAT)/1000
	            lat_min = int(int(LAT)%1000.0*.06)
	        elif tokens[4][1:5].isdigit():
	            LAT = tokens[4][1:5]
	            Quad = int(tokens[4][0:1])
	            lat_deg = int(LAT)/100
	            lat_min = int(int(LAT)%100.0*0.6)
	        elif tokens[4][1:4].isdigit():
	            LAT = tokens[4][1:4]
	            Quad = int(tokens[4][0:1])
	            lat_deg = int(LAT)/10
	            lat_min = int(int(LAT)%10.0*6)
	            
	        if tokens[5].isdigit():
	            LON = tokens[5][0:]
	            lon_deg = int(LON)/1000
	            lon_min = int(int(LON)%1000.0*0.06)
	        elif tokens[5][0:5].isdigit():
	            LON = tokens[5][0:5]
	            lon_deg = int(LON)/100
	            lon_min = int(int(LON)%100.0*0.6)
	        elif tokens[5][0:4].isdigit():
	            LON = tokens[5][0:4]
	            lon_deg = int(LON)/10
	            lon_min = int(int(LON)%10.0*6)
	            
	        Lat_Quad=''
	        Lon_Quad=''
	        if Quad == 7:
	            Lat_Quad= 'N'
	            Lon_Quad= 'W'
	        elif Quad == 5:
	            Lat_Quad= 'S'
	            Lon_Quad= 'W'
	        elif Quad == 3:
	            Lat_Quad= 'S'
	            Lon_Quad= 'E'
	        elif Quad == 1:
	            Lat_Quad= 'N'
	            Lon_Quad= 'E'

	        flags = []
	        for i in range(0,7):
	            flags.append(0)

	        Section1 = 0
	        Section2 = 0
	        Section3 = 0
	        Section4 = 0
	        Section5 = 0
	        for k in range(0,len(tokens)):
	            if tokens[k][0:3]=='111':
	                Section1=k
	            elif tokens[k][0:3]=='222':
	                Section2 = k
	            elif tokens[k][0:3]=='333':
	                Section3 = k
	            elif tokens[k][0:3]=='444':
	                Section4 = k
	            elif tokens[k][0:3]=='555':
	                Section5 = k
	        
	        if Section1 > 0: ## Section 1 exists
	            if Section2 >0:
	                for k in range(Section1+1, Section2):
	                    if tokens[k][0:1]=='0' and tokens[k][1:].isdigit():
	                        flags[0]=1
	                        flags[1]=1
	                    elif tokens[k][0:1]=='1' and tokens[k][1:].isdigit():
	                        flags[2]=1
	                    elif tokens[k][0:2]=='29' and tokens[k][2:].isdigit():
	                        flags[3]=1
	                    elif tokens[k][0:1]=='4' and tokens[k][1:].isdigit():
	                        flags[4]=1
	                    if tokens[Section2+1][0:1]=='0' and tokens[Section2+1][1:].isdigit():
	                        flags[6]=1
	            elif Section3 >0: #section 1 exist but section 2 doesn't
	                for k in range(Section1+1, Section3):
	                    if tokens[k][0:1]=='0' and tokens[k][1:].isdigit():
	                        flags[0]=1
	                        flags[1]=1
	                    elif tokens[k][0:1]=='1' and tokens[k][1:].isdigit():
	                        flags[2]=1
	                    elif tokens[k][0:2]=='29' and tokens[k][2:].isdigit():
	                        flags[3]=1
	                    elif tokens[k][0:1]=='4' and tokens[k][1:].isdigit():
	                        flags[4]=1
	            elif Section4 >0: #section 1 exist but section 2 and 3 don't
	                for k in range(Section1+1, Section4):
	                    if tokens[k][0:1]=='0' and tokens[k][1:].isdigit():
	                        flags[0]=1
	                        flags[1]=1
	                    elif tokens[k][0:1]=='1' and tokens[k][1:].isdigit():
	                        flags[2]=1
	                    elif tokens[k][0:2]=='29' and tokens[k][2:].isdigit():
	                        flags[3]=1
	                    elif tokens[k][0:1]=='4' and tokens[k][1:].isdigit():
	                        flags[4]=1
	            elif Section5 >0: #section 1 exist but section 2 and 3 don't
	                for k in range(Section1+1, Section5):
	                    if tokens[k][0:1]=='0' and tokens[k][1:].isdigit():
	                        flags[0]=1
	                        flags[1]=1
	                    elif tokens[k][0:1]=='1' and tokens[k][1:].isdigit():
	                        flags[2]=1
	                    elif tokens[k][0:2]=='29' and tokens[k][2:].isdigit():
	                        flags[3]=1
	                    elif tokens[k][0:1]=='4' and tokens[k][1:].isdigit():
	                        flags[4]=1

	            if Section3 >0: ## section 3 exists check for TZ
	                if tokens[Section3+1][0:2]=='888':
	                    flags[6]=1

	        OutRec = []
	        OutRec.append(WMO_ID)
	        OutRec.append('%02d/%02d/%04d' %(int(OM),int(OD),int(OY)))
	        OutRec.append('%04d' %(int(OT)))
	        OutRec.append(WMO_Header)
	#        print "ProcBathy ", WMO_Header
	        OutRec.append('%02d/%02d/%04d' %(HM,HD,HY))
	        OutRec.append('%04d' %(int(HT)))
	        OutRec.append('%02d/%02d%s' %(lat_deg,lat_min,Lat_Quad))
	        OutRec.append('%03d/%02d%s' %(lon_deg,lon_min,Lon_Quad))
	        
	        for i in range(0, len(flags)):
	            OutRec.append('%d' %flags[i])
	            
	        type='D'
	        if WMO_Header.find('SSVX08')>=0:
	            type='T'
	        elif WMO_Header.find('SOVX10KWBC')>=0:
	            type='F'
	        OutRec.insert(0,type)
	#        print OutRec
	        RetRecords.append(OutRec)
        except Exception, e:
            ARCHLog.exception(str(e))
            BAD.write('%s\r\n\n' %rec)
            continue

    return RetRecords

def ProcBathy():
    RetRecords = []
    for rec in Messages:
        try:
            tokens = rec.split()
    #        print tokens
    #        print
            offset =0
            if len(tokens)<=3:
                continue
    #        print "Length of tokens is ", len(tokens)
                
    #        WMO_ID=tokens[1]
            now = time.gmtime()   
    #        print tokens
            OD = tokens[1][0:2] # Ob Day
            OM = tokens[1][2:4] # ob Month
            OY1 = tokens[1][4:5] # ob Year digit
            OT = tokens[2][0:4]
            
            
            
            if OD.isdigit() and OM.isdigit() and OY1.isdigit() and OT.isdigit():
                if int(OY1) > now.tm_year%10:  ## year in observation greater than last digit in current year
                    if int(OY1) - now.tm_year%10 == 1:
                        OY = now.tm_year-1
                    elif int(OY1) - now.tm_year%10 > 1:  ## more than one year must be from previous decade
                        OY = now.tm_year/10*10 + int(OY1)-10
                else:
                    OY = now.tm_year/10*10 +int(OY1)
                    
                OD = int(OD)
            else:
                OD=now.tm_mday
                OM=now.tm_mon
                OY = now.tm_year
                OT = str(now.tm_hour*100+now.tm_min)
                
            if tokens[3].isdigit():
                LAT = tokens[3][1:]
                Quad = int(tokens[3][0:1])
                lat_deg = int(LAT)/1000
                lat_min = int(int(LAT)%1000.0*.06)
            elif tokens[3][1:5].isdigit():
                LAT = tokens[3][1:5]
                Quad = int(tokens[3][0:1])
                lat_deg = int(LAT)/100
                lat_min = int(int(LAT)%100.0*0.6)
            elif tokens[3][1:4].isdigit():
                LAT = tokens[3][1:4]
                Quad = int(tokens[3][0:1])
                lat_deg = int(LAT)/10
                lat_min = int(int(LAT)%10.0*6)
                
            if tokens[4].isdigit():
                LON = tokens[4][0:]
                lon_deg = int(LON)/1000
                lon_min = int(int(LON)%1000.0*0.06)
            elif tokens[4][0:5].isdigit():
                LON = tokens[4][0:5]
                lon_deg = int(LON)/100
                lon_min = int(int(LON)%100.0*0.6)
            elif tokens[4][0:4].isdigit():
                LON = tokens[4][0:4]
                lon_deg = int(LON)/10
                lon_min = int(int(LON)%10.0*6)
                
            Lat_Quad=''
            Lon_Quad=''
            if Quad == 7:
                Lat_Quad= 'N'
                Lon_Quad= 'W'
            elif Quad == 5:
                Lat_Quad= 'S'
                Lon_Quad= 'W'
            elif Quad == 3:
                Lat_Quad= 'S'
                Lon_Quad= 'E'
            elif Quad == 1:
                Lat_Quad= 'N'
                Lon_Quad= 'E'
            if '99999' in tokens:
                ind = tokens.index('99999')
                WMO_ID = tokens[ind+1]
                type = tokens[0][0:1]
            elif tokens[len(tokens)-1].upper()[0:1]=='Q':
                WMO_ID=tokens[len(tokens)-1]
                type ='F'
            else:
                WMO_ID=tokens[len(tokens)-1]
                type = tokens[0][0:1]
                

            OutRec = []
            OutRec.append(WMO_ID)
            OutRec.append('%02d/%02d/%04d' %(int(OM),int(OD),int(OY)))
            OutRec.append('%04d' %(int(OT)))
            OutRec.append(WMO_Header)
    #        print "ProcBathy ", WMO_Header
            OutRec.append('%02d/%02d/%04d' %(HM,HD,HY))
            OutRec.append('%04d' %(int(HT)))
            OutRec.append('%02d/%02d%s' %(lat_deg,lat_min,Lat_Quad))
            OutRec.append('%03d/%02d%s' %(lon_deg,lon_min,Lon_Quad))
            
            flags = []
            for i in range(0,7):
                flags.append(0)
            if tokens[5][0:3]=='888':  ## No Wind Speed and Direction
                flags[6]=1
            elif tokens[5][0:1] == '4':  ## Air Temperature
                if tokens[5].isdigit():
                    flags[2]=1
            elif tokens[5][1:].isdigit(): ## Wind Speed and direction encountered
                flags[0]=1
                flags[1]=1
                ## Check next element to see if it contains air temperature since this one does not
                if tokens[6][0:1]=='4':
                    if tokens[6].isdigit():
                        flags[2]=1
            for k in range(0, len(tokens)):
                if tokens[k][0:3]=='888':
                    flags[6]=1
                    if type =='K' or type == 'F':
                        if tokens[k+2][0:1]=='2':
                            ## found a depth check if surface temp
                            if tokens[k+2][1:].isdigit():
                                if int(tokens[k+2][1:]) < 3:
                                    flags[5]=1
                                    break
                    elif type == 'J':
                         if tokens[k+2].isdigit():
                            ## found a depth check if surface temp
                            if int(tokens[k+2][1:3]) < 3:
                                flags[5]=1
                                break
                            
            for i in range(0, len(flags)):
                OutRec.append('%d' %flags[i])
            OutRec.insert(0,type)
    #        print OutRec
            RetRecords.append(OutRec)
        except Exception, e:
            ARCHLog.exception(str(e))
            BAD.write('%s\r\n\n' %rec)
            continue

    return RetRecords



##*********************************************************##
def ProcBBXX():
#    print "in ProcBBXX"
#    print "len of Messages is %d" %(len(Messages))
    RetRecords = []
    BlockType1 = False
    if Messages[0].find("BBXX\r\r\n")>=0:  # Formatted with only one BBXX in the block.
        BlockType1 = True

    for rec in Messages:
        try:
            tokens = rec.split()
            offset =0
            if len(tokens)<=3:
                continue
    #        print "Length of tokens is ", len(tokens)
            if tokens[0].upper()=='BBXX':
                del tokens[0]
            if tokens[0].upper() =='STORM':  ## Delete the STORM at beginning of Canadian Auto Imet
                del tokens[0]
            if tokens[0].upper() =='SPREP':  ## Delete the STORM at beginning of Canadian Auto Imet
                del tokens[0]
            WMO_ID=tokens[0]
            now = time.gmtime()   
    #        print tokens
            OD = tokens[1][0:2] # Ob Day
            OT = tokens[1][2:4] # ob Time
            OM = now.tm_mon # Header Month
            OY = now.tm_year  # Header Year
            
            
            if OD.isdigit():
                OD = int(OD)
                if OD > now.tm_mday:
                    OM = OM -1
                    if OM < 1:
                        OM = 12
                        OY = OY-1
            else:
                OD=now.tm_mday
                OM=now.tm_mon
                OY = now.tm_year
            
            if tokens[2][0:2]=='99':
                if tokens[2].isdigit():
                    LAT = tokens[2][2:]
                else:
                    LAT=tokens[2][2:tokens[2].find('/')]
                Quad = int(tokens[3][0:1])
                if tokens[3].isdigit():
                    LON = tokens[3][1:]
                else:
                    LON=tokens[3][1:tokens[3].find('/')]
                lat_deg = int(LAT)/10
                lat_min = int(LAT)%10*6
                lon_deg = int(LON)/10
                lon_min = int(LON)%10*6
                Lat_Quad=''
                Lon_Quad=''
                if Quad == 7:
                    Lat_Quad= 'N'
                    Lon_Quad= 'W'
                elif Quad == 5:
                    Lat_Quad= 'S'
                    Lon_Quad= 'W'
                elif Quad == 3:
                    Lat_Quad= 'S'
                    Lon_Quad= 'E'
                elif Quad == 1:
                    Lat_Quad= 'N'
                    Lon_Quad= 'E'

                OutRec = []
                OutRec.append(WMO_ID)
                OutRec.append('%02d/%02d/%04d' %(OM,OD,OY))
                OutRec.append('%04d' %(int(OT)*100))
                OutRec.append(WMO_Header)
        #        print "ProcBBXX ", WMO_Header
                OutRec.append('%02d/%02d/%04d' %(HM,HD,HY))
                OutRec.append('%04d' %(int(HT)))
                OutRec.append('%02d/%02d%s' %(lat_deg,lat_min,Lat_Quad))
                OutRec.append('%03d/%02d%s' %(lon_deg,lon_min,Lon_Quad))
                section = 1
                flags = []
                for i in range(0,7):
                    flags.append(0)
                for i in range(4,len(tokens)):
                    if tokens[i][0:3] == '222':
                        section = 2
                    elif tokens[i][0:3] == '333':
                        section = 3
                    elif tokens[i][0:3] == '444':
                        section = 4
                    elif tokens[i][0:3] == '555':
                        section = 5
                    if section == 1 and i == 5:
                        if tokens[i][1:3].isdigit():
                            flags[0] = 1
                        if tokens [i][3:6].isdigit():
                            flags[1] = 1
                        continue
                    elif section == 1 and tokens[i][0:1] == '1'  and i > 5:
                        if tokens[i][1:].isdigit():
                            flags[2] = 1
                        continue
                    elif section == 1 and tokens[i][0:2] == '29'  and i > 5:
                        if tokens[i][2:].isdigit():
                            flags[3] =1
                        continue
                    elif section == 1 and tokens[i][0:1] == '4' and i > 5:
                        if tokens[i][1:].isdigit():
                            flags[4] = 1
                        continue
                    elif section == 1 and tokens[i][0:1] == '9'  and i > 5:  ## Observation time
                        if tokens[i][1:].isdigit():
                            del OutRec[2]
                            OutRec.insert(2,(tokens[i][1:]))
                        continue
                    elif section == 2 and tokens[i][0:1] == '0'  and i > 5:
                        if tokens[i][1:].isdigit():
                            flags[5] = 1
                        continue
                        
                for i in range(0, len(flags)):
                    OutRec.append('%d' %flags[i])
                OutRec.insert(0,'B')
                RetRecords.append(OutRec)
#                print "len of RetRecords is %d" %(len(RetRecords))
        except Exception, e:
            ARCHLog.exception(str(e))
            BAD.write('%s\r\n\n' %rec)
            continue
#        print OutRec

    return RetRecords
 ##       print rec
 ##       print '%s,%02d/%02d/%04d,%04d,%02d/%02d%s,%03d/%02d%s' %(WMO_ID, OM,OD,OY,int(OT)*100,lat_deg,lat_min,Lat_Quad,lon_deg,lon_min,Lon_Quad)
 
 
 
def goosMainProc(): 
	## Main Program

##	group = grp.getgrnam("AMVER")
	#	print group
	#os.chown(ARCHFile,group[2],group[2])
	#os.chmod(ARCHFile,0660)
##	os.setregid(group[2],group[2])
##	os.setreuid(group[2],group[2])

	global Messages, BAD, WMO_Header
	global HD, HT, HM, HY, now
	
	DBHost='localhost'
	
#	print "goosMainProc"

	start = time.time()

	try:
	  conn=psycopg2.connect("dbname='postgres' host='%s' user='seas' password='revjepeaws' connect_timeout=20" %DBHost)
	except Exception,e:
	##   ARCHLog.exception("Exception connecting to DB")
	  sys.exit(1)
	cur = conn.cursor()

	##BinFileLoc = 'h:'+'/tsg/'
	BinFileLoc = '/home/AMVER/NOSSRVR_lftp/goos/'
	#BinFileLoc = 'h:'+'/goos/'
	bindir = os.listdir(BinFileLoc)
	mytime = time.gmtime()


	GOOD_File_Name = "/home/AMVER/NOSSRVR_lftp/goos/GOOS%03d.DAT" %mytime.tm_yday
	Not_Found_File_Name = "/home/AMVER/NOSSRVR_lftp/goos/GOOS_NF%03d.DAT" %mytime.tm_yday
	BAD_File_Name = "/home/AMVER/NOSSRVR_lftp/goos/GOOS_BAD%03d.DAT" %mytime.tm_yday

	GOOD = open(GOOD_File_Name, 'w')
	Not_Found = open(Not_Found_File_Name, 'w')
	BAD = open(BAD_File_Name, 'w')
	for filename in bindir:
	    split  = os.path.splitext(filename)
	    if split[1].upper()=='.BIN':
	        if(os.path.isdir(BinFileLoc+filename)):
	           continue
	        infile = open(BinFileLoc+filename,'rb')
	#        ARCHLog.info("Processing "+BinFileLoc+files)
	        print "Processing "+BinFileLoc+filename
	        while (1):
	            header = infile.read(19)
	            resynch = False
	            if header.find('****')!=0  and header.find('****',4)!=14 and len(header)==19:
	                ipos = infile.tell()
	#                ARCHLog.info('Header error at position %d' %ipos)
	                print ('Header error at position %d' %ipos)
	                while (1):
	                    cinput = infile.read(1)
	#                    print cinput
	                    if not cinput:
	                        header=''
	                        break
	                    elif cinput=='*':
	                        infile.seek(-1,1)
	                        resynch = True  ##header = infile.read(19)
	                        break
	#                        print 'New Header'
	#                        print header
	            if resynch:
	                continue
	            if not header:
	                break
	            remain = int(header[4:14])
	            buf = infile.read(remain)
	            if len(buf) != remain:
	                print "BUF LEN, REMAIN",len(buf), remain
	                BAD.write("%s\r\n\n" %buf)
	                continue
	                          
	            buf = buf.upper()
	            if buf.find('IOPX01') >=0 or buf.find('IOSX01') >=0 or buf.find('IOPX02') >=0 or buf.find('IOBX01') >=0:
	                print "BUFR Bulletin"
	##                print buf
	                continue    ##BufrOut.write(header+buf)
	            elif buf.find('IOBX01') >=0: ## or buf.find('IOSX01') >=0 or buf.find('IOPX02') >=0:
	                print "Met BUFR Bulletin"
	##                print buf
	                continue    ##MetBufrOut.write(header+buf)

	            WMO_Header = buf[0:11].replace(' ','')
	#            print WMO_Header

	            Records=[]
	            now = time.gmtime()
	            HD = buf[12:14] # Header Day
	            HT = buf[14:18] # Header Time
	            HM = now.tm_mon # Header Month
	            HY = now.tm_year  # Header Year
	            
	            
	            if HD.isdigit():
	                HD = int(HD)
	                if HD > now.tm_mday:
	                    HM = HM -1
	                    if HM < 1:
	                        HM = 12
	                        HY = HY-1
	            else:
	                HD=now.tm_mday
	                HM=now.tm_mon
	                HY = now.tm_year
	                        
	            
	            
	#            print '%s,%02d/%02d/%04d,%04d' %(WMO_Header, HM,HD,HY,int(HT))



	# Split the number of messages in the bulletin
	            if buf.find('BBXX') >=0:
	                pos1 = buf.rfind('=')
	                if pos1>0:
	                    buf=buf[0:pos1]
	                buf = buf[buf.find('\r\r\n')+3:]
	                Messages = buf.split('=\r\r\n')
#	                print "calling ProcBBXX"
	                Records = ProcBBXX()
	                if len(Messages)==0:
	                    continue
	#            elif Messages[0].find('JJXX') or Messages[0].find('JJYY') or Messages[0].find('JJVV') or Messages[0].find('KKXX') or Messages[0].find('KKYY'):
	            elif buf.find('JJXX') >=0 or buf.find('JJYY') >=0 or buf.find('JJVV') >=0 or buf.find('KKXX') >=0  or buf.find('KKYY') >=0 :
	                pos1 = buf.rfind('=')
	                if pos1>0:
	                    buf=buf[0:pos1]
	                buf = buf[buf.find('\r\r\n')+3:]
	                Messages = buf.split('=')
	                Records = ProcBathy()
	            elif buf.find('ZZYY') >=0:
	                pos1 = buf.rfind('=')
	                if pos1>0:
	                    buf=buf[0:pos1]
	                buf = buf[buf.find('\r\r\n')+3:]
	                Messages = buf.split('=')
	                Records = ProcZZYY()
	            elif buf.find('NNXX')>=0:
	                pos1 = buf.rfind('=')
	                if pos1>0:
	                    buf=buf[0:pos1]
	                buf = buf[buf.find('\r\r\n')+3:]
	                Messages = buf.split('=')
	                Records = ProcNNXX()
	            stmt1 = "select WMO_ID from noaaships where wmo_id = upper('"
#	            print "len of records is %d" %len(Records)
	            if len(Records) > 0:
	                for R in Records:
	                    if R[1].isdigit() or (R[1].upper()[0:1]=='Q' and R[1][1:].isdigit()):
	                        GOOD.write("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\r\n"
	                                   %(R[0],R[1],R[2],R[3],R[4],R[5],R[6],R[7],R[8],R[9],R[10],R[11],R[12],R[13],R[14],R[15]))
	                    else:
	                    	if R[1].isalnum():
	                        	stmt2 = stmt1+"%s')" %R[1]
	                        else:
	                            Not_Found.write("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\r\n"
	                                       %(R[0],R[1],R[2],R[3],R[4],R[5],R[6],R[7],R[8],R[9],R[10],R[11],R[12],R[13],R[14],R[15]))
	                            continue
	                        	
#	                        print
#	                        print stmt2
	                        cur.execute(stmt2)
	                        found = cur.fetchall()
	                        if len(found)>0:
	                            GOOD.write("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\r\n"
	                                       %(R[0],R[1],R[2],R[3],R[4],R[5],R[6],R[7],R[8],R[9],R[10],R[11],R[12],R[13],R[14],R[15]))
	                        else:
	                            Not_Found.write("%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s\r\n"
	                                       %(R[0],R[1],R[2],R[3],R[4],R[5],R[6],R[7],R[8],R[9],R[10],R[11],R[12],R[13],R[14],R[15]))


	                
	        print filename
	        continue
	    
	##Close the files
	GOOD.close()
	Not_Found.close()
	BAD.close()

	os.chmod(GOOD_File_Name,0660)
	os.chmod(Not_Found_File_Name,0660)
	os.chmod(BAD_File_Name,0660)


	##close the DB Connections
	cur.close()
	conn.close()

	# copy the files to the nossrvr ftp location

	shutil.copy2(GOOD_File_Name, '/home/vftp/nossrvr/'+os.path.split(GOOD_File_Name)[1])
	shutil.copy2(Not_Found_File_Name, '/home/vftp/nossrvr/'+os.path.split(Not_Found_File_Name)[1])
	shutil.copy2(BAD_File_Name, '/home/vftp/nossrvr/'+os.path.split(BAD_File_Name)[1])

#	GOOD_File_Name = "/home/AMVER/NOSSRVR/goos/GOOS%03d.DAT" %mytime.tm_yday
#	Not_Found_File_Name = "/home/AMVER/NOSSRVR/goos/GOOS_NF%03d.DAT" %mytime.tm_yday
#	BAD_File_Name = "/home/AMVER/NOSSRVR/goos/GOOS_BAD%03d.DAT" %mytime.tm_yday

	Arch = os.path.split(GOOD_File_Name)

	zipPath = Arch[0]+'/archive/' + os.path.splitext(Arch[1])[0]+'_' +str(mytime.tm_year) +'.zip'

	print zipPath
	print GOOD_File_Name
	print os.path.split(GOOD_File_Name)[1]

	ArchFile = zipfile.ZipFile(zipPath,"w")

	ArchFile.write(GOOD_File_Name,os.path.split(GOOD_File_Name)[1],zipfile.ZIP_DEFLATED)
	ArchFile.write(Not_Found_File_Name,os.path.split(Not_Found_File_Name)[1],zipfile.ZIP_DEFLATED)
	ArchFile.write(BAD_File_Name,os.path.split(BAD_File_Name)[1],zipfile.ZIP_DEFLATED)

	ArchFile.close()

	os.chmod(zipPath,0660)

	os.unlink(GOOD_File_Name)
	os.unlink(Not_Found_File_Name)
	os.unlink(BAD_File_Name)

	for filenames in bindir:
		if os.path.splitext(filenames)[1].upper() == '.BIN':
			print filenames
			os.unlink(BinFileLoc+filenames)
		

	end = time.time()
	ARCHLog.debug( "total execution time = %f"  %((end-start)/60.0))



#***************************************************************************************************
def ReadConf(ConfigFile):
##    global CODE41Archive, CODE41Inbox, CODE43Inbox,  AMVERWorkDir, NWSMessOutDir, CODE43Archive
    global AMVERWorkDir, NOSFileDir, ARCHLog, Messages, BAD 
    if ConfigFile != '':
        try:
            nossrvr = open(ConfigFile,"r")
        except Exception, e:
            print str(e)
            sys.exit(2)
        
#        print "configfile is \n", ConfigFile
        InfoCount=0
        while 1:
            line=nossrvr.readline()
#            print line
            if len(line)==0:
                break
            colon = line.find(':')
#            print line[0:colon]
            if line[0:colon]=="AMVERWorkDir":
                AMVERWorkDir=line[colon+1:].strip()
        nossrvr.close() #close the config file
        return True
    else:
        return False

if __name__ == "__main__":
    logfile = 'goosProcLog'
#    NWSCollAddr  = "tggate.nws.noaa.gov"
#    NODCftp = "ftp.aoml.noaa.gov"
#    BathyDir= '/home/AMVER/SEAS/bathy/'
#    AOMLBUFRDestDir = 'PaulAOMLTest'
#    NODCDestDir = 'PaulNODCTest'
#    DeliverBUFRFiles ='false'
    AMVERWorkDir='/home/AMVER'
    ConfigFile=''
    pidfile = 'goosProc.pid'
    pidfileDir = '/home/AMVER/'
    version = 1.0
    
#  Change the user and group to amver and AMVER

    group = grp.getgrnam("AMVER")
#    print group
    os.setregid(group[2],group[2])
    os.setreuid(group[2],group[2])

#    sys.stderr.write(str(sys.argv) + str(len(sys.argv))+'\n')
    if len(sys.argv)>=2 and operator.mod(len(sys.argv),2)==0:
        command = sys.argv[1]
        for i in range(len(sys.argv)):
#            print ('%d  %s \n' % (i,sys.argv[i]))
            if i<2:
                pass
            elif operator.mod(i,2)==0:
                if sys.argv[i]== '-P':
                    pidfile=sys.argv[i+1]
                elif sys.argv[i]=='-L':
                    logfile=sys.argv[i+1]
                elif sys.argv[i]=='-C':
                    ConfigFile=sys.argv[i+1]
                    if ReadConf(ConfigFile):
 #                       print AMVERWorkDir, NWSCollAddr, DeliverBUFRFiles,  AOMLBUFRDestDir
                        pidfileDir = AMVERWorkDir
                        pass
                    else:
                        print " Failed to retrieve information from config file"
                        sys.exit(2)
            else:
                pass
        pidfile = (pidfileDir+pidfile)
        daemon = goosProcDaemon(pidfile)
        if 'start' == command:
            print "starting with pidfile = %s\r\n" %pidfile
            daemon.start()
#        else:
#            print "usage: %s start|stop|restart -P pidfile -L logfile -C ConfigFile" % sys.argv[0]
#            sys.exit(2)
#            sys.exit(0)
        elif 'stop' == command:
            daemon.stop()
        elif 'restart' == command:
            daemon.restart()
        elif sys.argv[i]=='-V':
            print 'version %6.2f' %version
        else:
            print "Unknown command"
            sys.exit(2)
    else:
        print "usage: %s start|stop|restart -P pidfile -L logfile -C ConfigFile Directory" % sys.argv[0]
        sys.exit(2)
